/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ScatterBase } from "./ScatterBase";
import { IScaleLegendSeries_$type } from "igniteui-angular-core";
import { ISupportsSizeScale_$type } from "./ISupportsSizeScale";
import { ISupportsFillScale_$type } from "./ISupportsFillScale";
import { Base, typeCast, Point_$type, fromEnum, markType, markDep, enumGetBox, runOn } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { UIElement } from "igniteui-angular-core";
import { ActualRange } from "./ActualRange";
import { DependencyProperty } from "igniteui-angular-core";
import { SizeScale } from "./SizeScale";
import { BrushScale } from "./BrushScale";
import { ScatterFrame } from "./ScatterFrame";
import { IChartLegend_$type } from "igniteui-angular-core";
import { ValueBrushScale } from "./ValueBrushScale";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { ScatterBaseView } from "./ScatterBaseView";
import { ScalerParams } from "./ScalerParams";
import { Dictionary$2 } from "igniteui-angular-core";
import { OwnedPoint } from "./OwnedPoint";
import { BubbleMarkerManager } from "./BubbleMarkerManager";
import { IChartItemLegend_$type } from "igniteui-angular-core";
import { IChartScaleLegend_$type } from "igniteui-angular-core";
import { ContentControl } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { DeviceUtils } from "igniteui-angular-core";
import { BrushUtil } from "igniteui-angular-core";
import { ChartSelection } from "./ChartSelection";
import { FastItemsSource } from "igniteui-angular-core";
import { FastItemColumn } from "igniteui-angular-core";
import { DataLegendSeriesValueInfo } from "igniteui-angular-core";
import { DataLegendSeriesContext } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_, isInfinity, logBase } from "igniteui-angular-core";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
import { BrushSelectionMode_$type } from "./BrushSelectionMode";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { Defaults } from "./Defaults";
/**
 * @hidden
 */
export let BubbleSeries = /*@__PURE__*/ (() => {
    class BubbleSeries extends ScatterBase {
        constructor() {
            super();
            this.aef = null;
            this.aee = null;
            this.ac2 = null;
            this.act = null;
            this.acs = null;
            this.acr = null;
            this.acp = null;
            this.ab = BubbleSeries.$;
            this.y0 = new ScatterFrame();
            this.y2 = new ScatterFrame();
            this.yy = new ScatterFrame();
        }
        bj() {
            return new BubbleSeries();
        }
        get_ei() {
            return true;
        }
        cs() {
            return new BubbleSeriesView(this);
        }
        qz(a) {
            super.qz(a);
            this.aco = a;
        }
        jl() {
            return 0.7;
        }
        wz() {
            if (this.wy == 0) {
                return 2;
            }
            return super.wz();
        }
        isAttachedTo(a) {
            return this.a5 == a;
        }
        eh() {
            return true;
        }
        p0(a) {
            super.p0(a);
            if (this.acx != null && this.ac2 != null && this.ac2.count > 0) {
                for (let b = 0; b < this.ac2.count; b++) {
                    a(this.ac2._inner[b]);
                }
            }
        }
        get acw() {
            return this.acy;
        }
        get_isColoredItemwise() {
            return this.acu != null && this.acu.count > 0;
        }
        aed(a) {
            let b = typeCast(CustomPaletteBrushScale.$, this.acn);
            let c = typeCast(ValueBrushScale.$, this.acn);
            let d = this.acn;
            if (b != null && this.dn != null) {
                return b.getBrush1(a, this.dn.count);
            }
            else if (c != null) {
                return c.getBrushByIndex(a, this.acu);
            }
            else if (d != null) {
                return d.getBrush(a);
            }
            return null;
        }
        get legendReady() {
            return this.acy != null && this.acy.count != 0;
        }
        get minScaleText() {
            let a = this.acm(this.acq).b;
            return (Math.round(a * 1000) / 1000).toString();
        }
        get maxScaleText() {
            let a = this.acm(this.acq).a;
            return (Math.round(a * 1000) / 1000).toString();
        }
        forScaleColors(a) {
            for (let b = 0; b < this.acy.count; b++) {
                if (this.acn == null || !this.acn.isReady) {
                    return false;
                }
                let c = NaN;
                if (this.acu != null) {
                    c = (this.acu.item(b) - this.acu.minimum) / (this.acu.maximum - this.acu.minimum);
                }
                let d = (this.acy.item(b) - this.acy.minimum) / (this.acy.maximum - this.acy.minimum);
                if (isNaN_(c)) {
                    c = 0;
                }
                if (isNaN_(d)) {
                    d = c;
                }
                let e = this.yf;
                let f = this.aed(b);
                let g = f != null ? f : e;
                a(g, d);
            }
            return true;
        }
        kq(a, b) {
            let c = this.nd(b);
            if (c == BubbleSeries.$$p[5]) {
                return this.kr(a, b, this.adh);
            }
            if (c == BubbleSeries.$$p[11]) {
                return this.kr(a, b, this.adr);
            }
            if (c == ScatterBase.$$p[12]) {
                return this.kr(a, b, this.aar);
            }
            if (c == ScatterBase.$$p[16]) {
                return this.kr(a, b, this.aaz);
            }
            if (c == BubbleSeries.$$p[2]) {
                return this.kr(a, b, this.adc);
            }
            return super.kq(a, b);
        }
        md(a) {
            let b = this.nd(a);
            if (b == BubbleSeries.$$p[5]) {
                return this.adh;
            }
            if (b == BubbleSeries.$$p[11]) {
                return this.adr;
            }
            if (b == ScatterBase.$$p[12]) {
                return this.aar;
            }
            if (b == ScatterBase.$$p[16]) {
                return this.aaz;
            }
            if (b == BubbleSeries.$$p[2]) {
                return this.adc;
            }
            return super.md(a);
        }
        get acy() {
            return this.act;
        }
        set acy(a) {
            if (this.act != a) {
                let b = this.acy;
                this.act = a;
                this.raisePropertyChanged("RadiusColumn", b, this.acy);
            }
        }
        get acx() {
            return this.acs;
        }
        set acx(a) {
            if (this.acs != a) {
                let b = this.acx;
                this.acs = a;
                this.raisePropertyChanged("LabelColumn", b, this.acx);
            }
        }
        get acu() {
            return this.acr;
        }
        set acu(a) {
            if (this.acr != a) {
                let b = this.acu;
                this.acr = a;
                this.raisePropertyChanged("FillColumn", b, this.acu);
            }
        }
        aa2(a, b, c, d, e) {
            if (c <= this.z7) {
                b.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, c);
            }
            let f = this.z7;
            let g = this.dn;
            let h;
            let i;
            let j = this.getEffectiveViewport1(a);
            let k = new ScalerParams(0, d, e, this.yu.d, j);
            let l = new ScalerParams(0, d, e, this.yu.e, j);
            let m = false;
            let n = 0;
            if (this.db != null) {
                if (this.db.f4()) {
                    let o = this.db.m4(d, k);
                    m = o.c;
                    n = o.d;
                }
            }
            for (let p = 0; p < c; p++) {
                h = this.zf.item(p);
                i = this.zg.item(p);
                let q = { $type: Point_$type, x: this.yu.a.el(h, k), y: this.yu.b.el(i, l) };
                if (m) {
                    if (q.x < e.left || q.x > e.right) {
                        if (q.x + n >= e.left && q.x + n <= e.right) {
                            q = { $type: Point_$type, x: q.x + n, y: i };
                        }
                    }
                }
                if (!isInfinity(q.x) && !isInfinity(q.y)) {
                    let r = g.item(p);
                    if (c <= f) {
                        if (!b.g.containsKey(r)) {
                            let s = { $type: Point_$type, x: h, y: i };
                            b.g.addItem(r, ((() => {
                                let $ret = new OwnedPoint();
                                $ret.a = r;
                                $ret.b = s;
                                $ret.c = q;
                                return $ret;
                            })()));
                        }
                    }
                }
            }
        }
        abd(a, b) {
            let c = typeCast(BubbleSeriesView.$, b);
            let d = c.c0;
            d.m = this.acy;
            super.abd(a, b);
            let e = Math.min(this.zf != null ? this.zf.count : 0, this.zg != null ? this.zg.count : 0);
            if (e < 1) {
                return;
            }
            c.dm();
            c.dn();
        }
        adw() {
            if (this.db == null) {
                return;
            }
            if (this.a5 == null) {
                return;
            }
            if (this.a5.isItemwise) {
                let a = this.a5;
                this.a5.clearLegendItemsForSeries(this);
                this.adv();
                a.renderItemwiseContent(this);
            }
            if (this.a5.isScale) {
                let b = this.a5;
                b.restoreOriginalState();
                b.initializeLegend(this);
            }
        }
        static ac3(a, b, c, d, e) {
            if (e <= a || isNaN_(e) || isInfinity(e)) {
                return c;
            }
            if (e >= b) {
                return d;
            }
            let f = c + ((d - c) / (b - a)) * (e - a);
            return f;
        }
        static ac4(a, b, c, d, logBase_, e) {
            let f = logBase(e, logBase_);
            let g = logBase(a, logBase_);
            let h = logBase(b, logBase_);
            return BubbleSeries.ac3(g, h, c, d, f);
        }
        he(a, b, c) {
            let d = super.he(a, b, c);
            if (this.acy == null || this.dn == null || this.acy.count == 0 || this.dn.count != this.acy.count) {
                d = false;
            }
            return d;
        }
        zp(a, b) {
            if (b != 3) {
                return true;
            }
            if (a == null) {
                return true;
            }
            if (this.aar == a || this.aaz == a || this.adr == a) {
                return true;
            }
            return false;
        }
        adv() {
            let a = typeCast(IChartLegend_$type, this.a5);
            if (a == null || this.dn == null) {
                return;
            }
            this.ac2 = new List$1(UIElement.$, 0);
            let b = typeCast(CustomPaletteBrushScale.$, this.acn);
            let c = typeCast(ValueBrushScale.$, this.acn);
            let d = this.acn;
            let e = this.acl();
            let f = e.b;
            let g = e.a;
            let h = this.dn;
            for (let i = 0; i < h.count; i++) {
                let j = null;
                if (c != null && this.acu != null) {
                    let k = this.acu.item(i);
                    j = c.getBrushByRange(k, f, g);
                }
                else if (b != null) {
                    j = b.getBrush1(i, h.count);
                }
                else if (d != null) {
                    j = d.getBrush(i);
                }
                let l = new ContentControl();
                let m = this.acx != null && this.acx.item(i) != null ? this.acx.item(i).toString() : "";
                l.content = ((() => {
                    let $ret = new DataContext();
                    $ret.series = this;
                    $ret.item = h.item(i);
                    $ret.itemBrush = j;
                    $ret.itemLabel = m;
                    $ret.legendLabel = m;
                    return $ret;
                })());
                let n = this.sv;
                if (n == null) {
                    n = this.cv.bn(this.c0);
                }
                l.ah = n;
                this.ac2.add(l);
            }
        }
        pb(a, b, c, d) {
            super.pb(a, b, c, d);
            if (this.acq != null) {
                this.acq.aa();
            }
            if (this.acn != null) {
                this.acn.x();
            }
            this.adw();
        }
        qb() {
            super.qb();
            this.adw();
        }
        qi() {
            super.qi();
            this.adw();
        }
        q7(a, b, c, d) {
            super.q7(a, b, c, d);
            switch (b) {
                case ScatterBase.$$p[10]:
                case ScatterBase.$$p[14]:
                case ScatterBase.$$p[11]:
                case ScatterBase.$$p[15]:
                case BubbleSeries.$$p[9]:
                case BubbleSeries.$$p[10]:
                    this.qd();
                    break;
                case "FastItemsSource":
                    if (this.acq != null) {
                        this.acq.aa();
                    }
                    if (this.acn != null) {
                        this.acn.x();
                    }
                    if (typeCast(IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.acy);
                        c.deregisterColumn(this.acu);
                        c.deregisterColumn(this.acx);
                        this.acy = null;
                        this.acu = null;
                        this.acx = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) != null) {
                        this.acy = this.dk(this.adr);
                        if (!stringIsNullOrEmpty(this.adc)) {
                            this.acu = this.dk(this.adc);
                        }
                        this.acx = this.dm(this.adh);
                    }
                    this.rp(false);
                    this.adw();
                    break;
                case BubbleSeries.$$p[11]:
                    if (this.acq != null) {
                        this.acq.aa();
                    }
                    if (this.dn != null) {
                        this.dn.deregisterColumn(this.acy);
                        this.acy = this.dk(this.adr);
                        this.adw();
                    }
                    break;
                case "RadiusColumn":
                    if (this.acq != null) {
                        this.acq.aa();
                    }
                    this.yv.c2.g$i();
                    this.rp(this.gg && this.d7);
                    this.qk();
                    break;
                case BubbleSeries.$$p[12]:
                    if (c != null) {
                        c.l.remove(this);
                        c.aa();
                    }
                    if (d != null) {
                        d.l.add(this);
                        d.aa();
                    }
                    this.rp(false);
                    this.qj();
                    break;
                case BubbleSeries.$$p[13]:
                    this.rp(false);
                    this.qj();
                    break;
                case "DiscreteLegendItemTemplate":
                    this.adw();
                    break;
                case BubbleSeries.$$p[3]:
                    if (c != null) {
                        c.o.remove(this);
                        c.x();
                    }
                    if (d != null) {
                        d.o.add(this);
                        d.x();
                    }
                    this.rp(false);
                    this.adw();
                    this.qj();
                    break;
                case BubbleSeries.$$p[4]:
                case BubbleSeries.$$p[8]:
                case BubbleSeries.$$p[7]:
                case BubbleSeries.$$p[6]:
                    this.rp(false);
                    this.adw();
                    this.qj();
                    break;
                case "FillColumn":
                    this.rp(this.gg && this.d7);
                    this.qj();
                    break;
                case BubbleSeries.$$p[2]:
                    if (this.acn != null) {
                        this.acn.x();
                    }
                    if (this.dn != null) {
                        this.dn.deregisterColumn(this.acu);
                        this.acu = this.dk(this.adc);
                        this.adw();
                    }
                    break;
                case BubbleSeries.$$p[5]:
                    if (this.dn != null) {
                        this.dn.deregisterColumn(this.acx);
                        this.acx = this.dm(this.adh);
                        this.adw();
                    }
                    break;
                case "ActualLegend":
                    let e = typeCast(IChartLegend_$type, c);
                    if (e != null && e.isItemwise) {
                        let f = typeCast(IChartItemLegend_$type, e);
                        f.clearLegendItemsForSeries(this);
                    }
                    if (e != null && e.isScale) {
                        let g = typeCast(IChartScaleLegend_$type, e);
                        let h = true;
                        let i = null;
                        if (this.db != null) {
                            for (let j of fromEnum(this.db.series)) {
                                if (j.legend == g) {
                                    i = j;
                                    h = false;
                                }
                            }
                        }
                        if (h) {
                            g.restoreOriginalState();
                        }
                        else {
                            g.initializeLegend(typeCast(IScaleLegendSeries_$type, i));
                        }
                    }
                    this.adw();
                    break;
                case "SeriesViewer":
                    this.adw();
                    break;
            }
        }
        updateSizeScaleGlobals() {
            let a = new ActualRange();
            a.b = NaN;
            a.a = NaN;
            if (this.acy != null) {
                a.b = this.acy.minimum;
                a.a = this.acy.maximum;
            }
            if (this.acq != null) {
                this.acq.ab(a.b, a.a);
            }
        }
        updateFillScaleGlobals() {
            let a = new ActualRange();
            a.b = NaN;
            a.a = NaN;
            if (this.acu != null) {
                a.b = this.acu.minimum;
                a.a = this.acu.maximum;
            }
            if (this.acn != null) {
                this.acn.z(a.b, a.a);
            }
        }
        acm(a) {
            let b = new ActualRange();
            b.b = NaN;
            b.a = NaN;
            if (this.acy != null) {
                b.b = this.acy.minimum;
                b.a = this.acy.maximum;
            }
            if (a != null) {
                a.x();
                if (this.ac1) {
                    b.b = a.globalMinimum;
                    b.a = a.globalMaximum;
                }
            }
            return b;
        }
        acl() {
            let a = new ActualRange();
            a.b = NaN;
            a.a = NaN;
            if (this.acu != null) {
                a.b = this.acu.minimum;
                a.a = this.acu.maximum;
            }
            let b = typeCast(ValueBrushScale.$, this.acn);
            if (b != null) {
                b.s();
                if (this.acz && this.acn.o.count > 1) {
                    a.b = b.q;
                    a.a = b.p;
                }
            }
            return a;
        }
        ady(a, b, c, d) {
            let e = c.width;
            if (!this.cv.bx.isEmpty) {
                e = this.cv.bx.width;
            }
            else if (this.db != null && !this.db.wj.isEmpty) {
                e = this.db.wj.width;
            }
            let f = DeviceUtils.c(e);
            this.acp = this.acq || ((() => {
                let $ret = new SizeScale();
                $ret.minimumValue = f / 10;
                $ret.maximumValue = f / 5;
                return $ret;
            })());
            if (this.acp != null) {
                let g = this.acp.minimumValue;
                let h = this.acp.maximumValue;
                let i = this.acp.logarithmBase;
                let j = this.acm(this.acp);
                let k = j.b;
                let l = j.a;
                if (this.acp.isLogarithmic) {
                    for (let m = 0; m < b.count; m++) {
                        b._inner[m] = BubbleSeries.ac4(k, l, g, h, i, b._inner[m]);
                    }
                }
                else {
                    for (let n = 0; n < b.count; n++) {
                        b._inner[n] = BubbleSeries.ac3(k, l, g, h, b._inner[n]);
                    }
                }
            }
            let o = 1;
            o = DeviceUtils.d();
            let p = this.acq == null;
            if (d) {
                let q = c.width / e;
                for (let r = 0; r < b.count; r++) {
                    if (p) {
                        b._inner[r] = b._inner[r] / o;
                    }
                    b._inner[r] = b._inner[r] * q;
                }
            }
            for (let s = 0; s < a.count; s++) {
                let t = a._inner[s];
                if (p && !d) {
                    t.width = Math.max(0, b._inner[s] / o);
                    t.height = Math.max(0, b._inner[s] / o);
                }
                else {
                    t.width = Math.max(0, b._inner[s]);
                    t.height = Math.max(0, b._inner[s]);
                }
            }
        }
        adx(a) {
            let b = typeCast(BubbleSeriesView.$, this.cu);
            this.aco.b7 = false;
            if (b != null) {
                b.b7 = false;
            }
            let c = typeCast(CustomPaletteBrushScale.$, this.acn);
            let d = typeCast(ValueBrushScale.$, this.acn);
            let e = this.acn;
            let f = this.acl();
            let g = f.b;
            let h = f.a;
            let i = this.acn == null || !this.acn.isReady || (d != null && this.adc == null);
            if (i) {
                this.aco.dl();
                if (b != null) {
                    b.dl();
                }
                return;
            }
            this.aco.b7 = true;
            if (b != null) {
                b.b7 = true;
            }
            let j = a.count;
            let k = this.dn;
            for (let l = 0; l < j; l++) {
                let m = a._inner[l];
                let n = typeCast(DataContext.$, m.content);
                if (n != null) {
                    let o = null;
                    let p = k.indexOf(n.item);
                    if (c != null) {
                        o = c.getBrush1(p, k.count);
                    }
                    else if (d != null && this.acu != null) {
                        let q = this.acu.item(p);
                        o = d.getBrushByRange(q, g, h);
                    }
                    else if (e != null) {
                        o = e.getBrush(p);
                    }
                    else {
                        if (this.yh == null) {
                            o = this.yf;
                        }
                        else {
                            o = this.yh;
                        }
                    }
                    let r = null;
                    if (this.yi == null) {
                        r = this.yg;
                    }
                    else {
                        r = this.yi;
                    }
                    if (this.ac0 && o != null) {
                        r = o;
                    }
                    if (r != null && !isNaN_(this.ac6)) {
                        r = BrushUtil.m(r, this.ac6);
                    }
                    if (o != null && !isNaN_(this.ac5)) {
                        o = BrushUtil.m(o, this.ac5);
                    }
                    n.itemBrush = o;
                    n.actualItemBrush = o;
                    n.outline = r;
                }
            }
        }
        ak(a, b) {
            let c = new List$1(ChartSelection.$, 0);
            this.p2(a, c, b);
            return c.toArray();
        }
        p2(a, b, c) {
            let d = 1;
            if (d == 1) {
                let e = this.acv();
                this.aa5(a, b, c, d, e);
            }
            else {
                super.p2(a, b, c);
            }
        }
        acv() {
            let a = new FastItemColumn(typeCast(FastItemsSource.$, this.dn), "RadiusColumn", null, false);
            let b = this.cv.bx;
            let c = b.width;
            if (!this.cv.bx.isEmpty) {
                c = this.cv.bx.width;
            }
            else if (this.db != null && !this.db.wj.isEmpty) {
                c = this.db.wj.width;
            }
            let d = DeviceUtils.c(c);
            this.acp = this.acq || ((() => {
                let $ret = new SizeScale();
                $ret.minimumValue = d / 10;
                $ret.maximumValue = d / 5;
                return $ret;
            })());
            if (this.acp != null) {
                let e = this.acp.minimumValue;
                let f = this.acp.maximumValue;
                let g = this.acp.logarithmBase;
                let h = this.acm(this.acp);
                let i = h.b;
                let j = h.a;
                if (this.acp.isLogarithmic) {
                    for (let k = 0; k < a.count; k++) {
                        a.item(k, BubbleSeries.ac4(i, j, e, f, g, a.item(k)));
                    }
                }
                else {
                    for (let l = 0; l < a.count; l++) {
                        a.item(l, BubbleSeries.ac3(i, j, e, f, a.item(l)));
                    }
                }
            }
            let m = DeviceUtils.d();
            let n = this.acq == null;
            let o = this.cv == this.cu;
            if (o) {
                let p = b.width / c;
                for (let q = 0; q < a.count; q++) {
                    if (n) {
                        a.item(q, a.item(q) / m);
                    }
                    a.item(q, a.item(q) * p);
                }
            }
            for (let r = 0; r < a.count; r++) {
                let s;
                if (n && !o) {
                    a.item(r, Math.max(0, a.item(r) / m));
                }
                else {
                    a.item(r, Math.max(0, a.item(r)));
                }
            }
            return a;
        }
        getDataLegendSeriesContextAt(a, b) {
            let c = { $type: Point_$type, x: a, y: b };
            let d = this.kn(c);
            let e = d == null ? NaN : this.ix(d, "XMemberPath");
            let f = d == null ? NaN : this.ix(d, "YMemberPath");
            let g = new DataLegendSeriesValueInfo();
            g.a = 13;
            g.l = e;
            g.q = "X";
            g.r = this.aar != null ? this.aar : "X";
            g.s = this.aan != null ? this.aan : "X:";
            g.t = this.aap != null ? this.aap : "";
            let h = new DataLegendSeriesValueInfo();
            h.l = f;
            h.a = 14;
            h.q = "Y";
            h.r = this.aaz != null ? this.aaz : "Y";
            h.s = this.aav != null ? this.aav : "Y:";
            h.t = this.aax != null ? this.aax : "";
            let i = new DataLegendSeriesContext();
            i.e = ((() => {
                let $ret = new List$1(DataLegendSeriesValueInfo.$, 0);
                $ret.add(g);
                $ret.add(h);
                return $ret;
            })());
            i.h = this.mc();
            if (!stringIsNullOrEmpty(this.adr)) {
                let j = d == null ? NaN : this.ix(d, "RadiusMemberPath");
                let k = new DataLegendSeriesValueInfo();
                k.l = j;
                k.a = 11;
                k.q = "Radius";
                k.r = this.adr != null ? this.adr : "Radius";
                k.s = this.adn != null ? this.adn : "R:";
                k.t = this.adp != null ? this.adp : "";
                i.e.add(k);
            }
            else if (this.acp != null) {
                let l = new DataLegendSeriesValueInfo();
                l.l = this.acp.maximumValue;
                l.a = 11;
                l.q = "Radius";
                l.r = this.adr != null ? this.adr : "Radius";
                l.s = this.adn != null ? this.adn : "R:";
                l.t = this.adp != null ? this.adp : "";
                i.e.add(l);
            }
            if (!stringIsNullOrEmpty(this.adc)) {
                let m = d == null ? NaN : this.ix(d, "FillMemberPath");
                let n = new DataLegendSeriesValueInfo();
                n.l = m;
                n.a = 12;
                n.q = "Fill";
                n.r = this.adc != null ? this.adc : "Fill";
                n.s = this.ac8 != null ? this.ac8 : "F:";
                n.t = this.ada != null ? this.ada : "";
                i.e.add(n);
            }
            return i;
        }
        get actualMarkerBrush() {
            return this.yf;
        }
    }
    BubbleSeries.$t = markType(BubbleSeries, 'BubbleSeries', ScatterBase.$, [IScaleLegendSeries_$type, ISupportsSizeScale_$type, ISupportsFillScale_$type]);
    BubbleSeries.$$p = markDep(DependencyProperty, PropertyMetadata, BubbleSeries, 'raisePropertyChanged', ['FillMemberAsLegendLabel:ac8:adz', [2, null], 'FillMemberAsLegendUnit:ada:ad0', [2, null], 'FillMemberPath:adc:ad1', [2], 'FillScale:acn:ad2', [BrushScale.$], 'FillScaleUseGlobalValues:acz:ad3', [0, false], 'LabelMemberPath:adh:ad4', [2], 'MarkerBrushBrightness:ac5:ad5', [1, NaN], 'MarkerOutlineBrightness:ac6:ad6', [1, NaN], 'MarkerOutlineUsesFillScale:ac0:ad7', [0, false], 'RadiusMemberAsLegendLabel:adn:ad8', [2, null], 'RadiusMemberAsLegendUnit:adp:ad9', [2, null], 'RadiusMemberPath:adr:aea', [2, null], 'RadiusScale:acq:aeb', [SizeScale.$], 'RadiusScaleUseGlobalValues:ac1:aec', [0, false]]);
    return BubbleSeries;
})();
/**
 * @hidden
 */
export let CustomPaletteBrushScale = /*@__PURE__*/ (() => {
    class CustomPaletteBrushScale extends BrushScale {
        constructor() {
            super();
        }
        getBrush1(a, b) {
            if (this.brushes == null || this.brushes.count == 0) {
                return null;
            }
            if (this.brushSelectionMode == 0) {
                return super.getBrush(a % this.brushes.count);
            }
            let c = BubbleSeries.ac3(0, b - 1, 0, this.brushes.count - 1, a);
            return this.ab(c);
        }
        get_isReady() {
            return this.brushes != null && this.brushes.count > 0;
        }
    }
    CustomPaletteBrushScale.$t = markType(CustomPaletteBrushScale, 'CustomPaletteBrushScale', BrushScale.$);
    CustomPaletteBrushScale.$$p = markDep(DependencyProperty, PropertyMetadata, CustomPaletteBrushScale, 'v', ['BrushSelectionMode', [BrushSelectionMode_$type, enumGetBox(BrushSelectionMode_$type, 0)]]);
    return CustomPaletteBrushScale;
})();
/**
 * @hidden
 */
export let BubbleSeriesView = /*@__PURE__*/ (() => {
    class BubbleSeriesView extends ScatterBaseView {
        constructor(a) {
            super(a);
            this.dk = null;
            this.dk = a;
            this.c2 = new ScatterTrendLineManager();
        }
        au() {
            super.au();
            if (!this.q) {
                this.b4.w8 = Defaults.e;
            }
        }
        cz() {
            return new BubbleMarkerManager((a) => this.c3.item(a), (a) => this.c1.yu.c.item(a), runOn(this, this.de), runOn(this, this.cw), runOn(this, this.c4));
        }
        dm() {
            let a = this.c0;
            this.dk.ady(a.n, a.o, this.bx, this == this.e.cu);
            this.as();
        }
        dn() {
            let a = this.c0;
            this.dk.adx(a.n);
        }
        dl() {
            let a = this.c0;
            for (let b of fromEnum(a.n)) {
                let c = typeCast(DataContext.$, b.content);
                if (c != null) {
                    c.itemBrush = null;
                    c.outline = null;
                }
            }
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'><span";
            let b = this.e.ba.a$u(this.e);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.dk.title + "</span><br/><span>" + "(${item." + this.dk.aar + "}, ${item." + this.dk.aaz + "})</span>";
            if (!stringIsNullOrEmpty(this.dk.adr)) {
                a += "<span>, Radius: ${item." + this.dk.adr + "}</span>";
            }
            a += "</div>";
            return a;
        }
    }
    BubbleSeriesView.$t = markType(BubbleSeriesView, 'BubbleSeriesView', ScatterBaseView.$);
    return BubbleSeriesView;
})();
